{
 clipping is performed by Sutherland-Hodgeman algoritm.

 Main formula for calculating line to line collision:
 We have 2 lines (XA,YA)-(XB,YB); (XC,YC)-(XD,YD);
 X=XA+(XB-XA)*t1 = XC+(XD-XC)*t2;
 X=YA+(YB-YA)*t1 = YC+(YD-YC)*t2;

     (XC-XA)*(YC-YD)-(XC-XD)*(YC-YA)
 t1:=-------------------------------
     (XB-XA)*(YC-YD)-(XC-XD)*(YB-YA)

     (XB-XA)*(YC-YA)-(XC-XA)*(YB-YA)
 t2:=-------------------------------
     (XB-XA)*(YC-YD)-(XC-XD)*(YB-YA)
}

Function ClipPoly(src,Dst:TPolygonPtr; Num:byte):byte;
var n:integer;
    dsti:integer;
    max:integer;
    v1,v2:integer;
    vert:array[1..20] of TVertex3dFix;
    a:fixed;
    final:pointer;
Label cont,cont1,cont2,cont3;
{$IFDEF Z_CLIPPING}
  Label cont4,cont5;
{$ENDIF}
begin
   final:=dst;
   Max:=Num;
   {CLIP BOTTOM}
   dsti:=1;
   for n:=1 to Max do begin
      v1:=n;
      v2:=n+1;
      if v2>max then v2:=1;
      if Src^[v1].y<=ClipBot then begin
         Dst^[dsti]:=Src^[v1];    {add visible vertex to list}
         dsti:=dsti+1;
         if Src^[v2].y<=ClipBot then GoTo cont  {next vertex visible too}
      end
      {none of 2 near vertexes visible; skip to next}
      else if Src^[v2].y>ClipBot then GoTo cont;
      {second vertex not visible}
{
      CD - horizontal line
      use formula:
                         (XB-XA)*(YC-YA)
                    X=XA+---------------
                             (YB-YA)
}
           a:=mFixedDiv(ClipBot-Src^[v1].y,Src^[v2].y-Src^[v1].y);
           Dst^[dsti].x:=Src^[v1].x+mFixedMul(a,Src^[v2].x-Src^[v1].x);
           Dst^[dsti].y:=ClipBot;
{$IFDEF CLIP_UPDATE_Z}
           Dst^[dsti].z:=Src^[v1].z+mFixedMul(a,Src^[v2].z-Src^[v1].z);
{$ENDIF}
{$IFDEF CLIP_UPDATE_UV}
           Dst^[dsti].u:=Src^[v1].u+mFixedMul(a,Src^[v2].u-Src^[v1].u);
           Dst^[dsti].v:=Src^[v1].v+mFixedMul(a,Src^[v2].v-Src^[v1].v);
{$ENDIF}
{$IFDEF CLIP_UPDATE_COLOR}
           Dst^[dsti].color:=Src^[v1].color+
                 mFixedMul(a,Src^[v2].color-Src^[v1].color);
{$ENDIF}
           dsti:=dsti+1;

cont:
   end;

   max:=dsti-1;


   {CLIP TOP}
   src:=dst; dst:=@vert;

   dsti:=1;
   for n:=1 to Max do begin
      v1:=n;
      v2:=n+1;
      if v2>max then v2:=1;
      if Src^[v1].y>=ClipTop then begin
         Dst^[dsti]:=Src^[v1];    {add visible vertex to list}
         dsti:=dsti+1;
         if Src^[v2].y>=ClipTop then GoTo cont1  {next vertex visible too}
      end
      {none of 2 near vertexes visible; skip to next}
      else if Src^[v2].y<ClipTop then GoTo cont1;
      {second vertex not visible}
           a:=mFixedDiv(ClipTop-Src^[v1].y,Src^[v2].y-Src^[v1].y);
           Dst^[dsti].x:=Src^[v1].x+mFixedMul(a,Src^[v2].x-Src^[v1].x);
           Dst^[dsti].y:=ClipTop;
{$IFDEF CLIP_UPDATE_Z}
           Dst^[dsti].z:=Src^[v1].z+mFixedMul(a,Src^[v2].z-Src^[v1].z);
{$ENDIF}
{$IFDEF CLIP_UPDATE_UV}
           Dst^[dsti].u:=Src^[v1].u+mFixedMul(a,Src^[v2].u-Src^[v1].u);
           Dst^[dsti].v:=Src^[v1].v+mFixedMul(a,Src^[v2].v-Src^[v1].v);
{$ENDIF}
{$IFDEF CLIP_UPDATE_COLOR}
           Dst^[dsti].color:=Src^[v1].color+
                 mFixedMul(a,Src^[v2].color-Src^[v1].color);
{$ENDIF}
           dsti:=dsti+1;
cont1:
   end;
   dst^[dsti]:=dst^[1];
   max:=dsti-1;

   dst:=src;
   Src:=@vert;

   { CLIP LEFT }
   dsti:=1;
   for n:=1 to Max do begin
      v1:=n;
      v2:=n+1;
      if v2>max then v2:=1;
      if Src^[v1].x>=ClipLeft then begin
         Dst^[dsti]:=Src^[v1];    {add visible vertex to list}
         dsti:=dsti+1;
         if Src^[v2].x>=ClipLeft then GoTo cont2  {next vertex visible too}
      end
      {none of 2 near vertexes visible; skip to next}
      else if Src^[v2].x<ClipLeft then GoTo cont2;
      {second vertex not visible}
           a:=mFixedDiv(ClipLeft-Src^[v1].x,Src^[v2].x-Src^[v1].x);
           Dst^[dsti].x:=ClipLeft;
           Dst^[dsti].y:=Src^[v1].y+mFixedMul(a,Src^[v2].y-Src^[v1].y);
{$IFDEF CLIP_UPDATE_Z}
           Dst^[dsti].z:=Src^[v1].z+mFixedMul(a,Src^[v2].z-Src^[v1].z);
{$ENDIF}
{$IFDEF CLIP_UPDATE_UV}
           Dst^[dsti].u:=Src^[v1].u+mFixedMul(a,Src^[v2].u-Src^[v1].u);
           Dst^[dsti].v:=Src^[v1].v+mFixedMul(a,Src^[v2].v-Src^[v1].v);
{$ENDIF}
{$IFDEF CLIP_UPDATE_COLOR}
           Dst^[dsti].color:=Src^[v1].color+
                 mFixedMul(a,Src^[v2].color-Src^[v1].color);
{$ENDIF}
           dsti:=dsti+1;
cont2:
   end;
   max:=dsti-1;

   src:=dst;
   dst:=@vert;
{CLIP RIGHT}
   dsti:=1;
   for n:=1 to Max do begin
      v1:=n;
      v2:=n+1;
      if v2>max then v2:=1;
      if Src^[v1].x<=ClipRight then begin
         Dst^[dsti]:=Src^[v1];    {add visible vertex to list}
         dsti:=dsti+1;
         if Src^[v2].x<=ClipRight then GoTo cont3  {next vertex visible too}
      end
      {none of 2 near vertexes visible; skip to next}
      else if Src^[v2].x>ClipRight then GoTo cont3;
      {second vertex not visible}
           a:=mFixedDiv(ClipRight-Src^[v1].x,Src^[v2].x-Src^[v1].x);
           Dst^[dsti].x:=ClipRight;
           Dst^[dsti].y:=Src^[v1].y+mFixedMul(a,Src^[v2].y-Src^[v1].y);
{$IFDEF CLIP_UPDATE_Z}
           Dst^[dsti].z:=Src^[v1].z+mFixedMul(a,Src^[v2].z-Src^[v1].z);
{$ENDIF}
{$IFDEF CLIP_UPDATE_UV}
           Dst^[dsti].u:=Src^[v1].u+mFixedMul(a,Src^[v2].u-Src^[v1].u);
           Dst^[dsti].v:=Src^[v1].v+mFixedMul(a,Src^[v2].v-Src^[v1].v);
{$ENDIF}
{$IFDEF CLIP_UPDATE_COLOR}
           Dst^[dsti].color:=Src^[v1].color+
                 mFixedMul(a,Src^[v2].color-Src^[v1].color);
{$ENDIF}
           dsti:=dsti+1;

cont3:
   end;
   max:=dsti-1;

{$IFDEF Z_CLIPPING}
   dst:=src;
   src:=@vert;
{CLIP BY MaxZ}
   dsti:=1;
   for n:=1 to Max do begin
      v1:=n;
      v2:=n+1;
      if v2>max then v2:=1;
      if Src^[v1].z<=MaxZClip then begin
         Dst^[dsti]:=Src^[v1];    {add visible vertex to list}
         dsti:=dsti+1;
         if Src^[v2].z<=MaxZClip then GoTo cont4  {next vertex visible too}
      end
      {none of 2 near vertexes visible; skip to next}
      else if Src^[v2].z>MaxZClip then GoTo cont4;
      {second vertex not visible}
           a:=mFixedDiv(MaxZClip-Src^[v1].z,Src^[v2].z-Src^[v1].z);
           Dst^[dsti].x:=Src^[v1].x+mFixedMul(a,Src^[v2].x-Src^[v1].x);
           Dst^[dsti].y:=Src^[v1].y+mFixedMul(a,Src^[v2].y-Src^[v1].y);
           Dst^[dsti].z:=MaxZClip;
{$IFDEF CLIP_UPDATE_UV}
           Dst^[dsti].u:=Src^[v1].u+mFixedMul(a,Src^[v2].u-Src^[v1].u);
           Dst^[dsti].v:=Src^[v1].v+mFixedMul(a,Src^[v2].v-Src^[v1].v);
{$ENDIF}
{$IFDEF CLIP_UPDATE_COLOR}
           Dst^[dsti].color:=Src^[v1].color+
                 mFixedMul(a,Src^[v2].color-Src^[v1].color);
{$ENDIF}
           dsti:=dsti+1;

cont4:
   end;
   max:=dsti-1;

   src:=dst;
   dst:=@vert;
{CLIP BY MinZ}
   dsti:=1;
   for n:=1 to Max do begin
      v1:=n;
      v2:=n+1;
      if v2>max then v2:=1;
      if Src^[v1].z>=MinZClip then begin
         Dst^[dsti]:=Src^[v1];    {add visible vertex to list}
         dsti:=dsti+1;
         if Src^[v2].z>=MinZClip then GoTo cont5  {next vertex visible too}
      end
      {none of 2 near vertexes visible; skip to next}
      else if Src^[v2].z<MinZClip then GoTo cont5;
      {second vertex not visible}
           a:=mFixedDiv(MinZClip-Src^[v1].z,Src^[v2].z-Src^[v1].z);
           Dst^[dsti].x:=Src^[v1].x+mFixedMul(a,Src^[v2].x-Src^[v1].x);
           Dst^[dsti].y:=Src^[v1].y+mFixedMul(a,Src^[v2].y-Src^[v1].y);
           Dst^[dsti].z:=MinZClip;

{$IFDEF CLIP_UPDATE_UV}
           Dst^[dsti].u:=Src^[v1].u+mFixedMul(a,Src^[v2].u-Src^[v1].u);
           Dst^[dsti].v:=Src^[v1].v+mFixedMul(a,Src^[v2].v-Src^[v1].v);
{$ENDIF}
{$IFDEF CLIP_UPDATE_COLOR}
           Dst^[dsti].color:=Src^[v1].color+
                 mFixedMul(a,Src^[v2].color-Src^[v1].color);
{$ENDIF}
           dsti:=dsti+1;

cont5:
   end;
   max:=dsti-1;
{$ENDIF}

   move(Dst^,final^,(max)*SizeOf(TVertex3dFix));
--   if max<3 then ClipPoly:=0  else ClipPoly:=dsti-1;
   ClipPoly:=max;
End;