Procedure DrawGoraudPoly16(poly:TPolygonPtr; Num:byte; Color:word; Where:TPageType);
{ poly - polygon structure }
{ Num  - number of vertexes in poly}
{ Color - base filling color for flat polygons}
{ Note: Vertexes must go in clockwise direction }
{ Using z coordinate as color index}
Type rgb=record r,g,b:fixed end;
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;

    LeftColor,RightColor,LeftColorStep,RightColorStep,ColorStep:rgb;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;
    BaseColor:fixed;

Procedure LoadColor(col:fixed; var dst:rgb);
 begin
   dst.r:=(((col shr 16) shr VesaModeInfo.RedFieldPosition) AND MaxRed) shl 16;
   dst.g:=(((col shr 16) shr VesaModeInfo.GreenFieldPosition) AND MaxGreen) shl 16;
   dst.b:=(((col shr 16) shr VesaModeInfo.BlueFieldPosition) AND MaxBlue) shl 16;
 end;

Procedure LeftSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
      color2:rgb;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 1 then NewVertex=vertex number 4}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      LeftVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      LeftVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, LeftSectionSize will always be >0}
      LeftSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if LeftSectionSize=0 then exit;
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      {divide xlen by ylen}
      CurrLeftX:=Poly^[vrtx1].x;
      LeftStepX:=mFixedDiv(Poly^[vrtx2].x-CurrLeftX,height);

--      DECLARE var prestep:fixed; begin
--         prestep:=mFixedRound(Poly^[vrtx1].y) - Poly^[vrtx1].y;
--         CurrLeftX+:=mFixedMul(prestep,LeftStepX);
--      end;

      LoadColor(Poly^[vrtx1].color,LeftColor);
      LoadColor(Poly^[vrtx2].color,Color2);
      LeftColorStep.g:=mFixedDiv(color2.g-LeftColor.g,height);
      if DACtype=BGRdac then begin
        LeftColorStep.r:=mFixedDiv(color2.r-LeftColor.r,height);
        LeftColorStep.b:=mFixedDiv(color2.b-LeftColor.b,height);
      end else begin
        {exchange blue and red values}
        LeftColorStep.b:=mFixedDiv(color2.r-LeftColor.r,height);
        LeftColorStep.r:=mFixedDiv(color2.b-LeftColor.b,height);
{exchange blue and red values in starting colors. Use height as temporary variable}
        height:=LeftColor.r; LeftColor.r:=LeftColor.b; LeftColor.b:=height;
      end;

--      LoadColor(Poly^[vrtx1].color+BaseColor,LeftColor);
  end;

Procedure RightSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
      color2:rgb;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 4 then NewVertex=vertex number 1}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      RightVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      RightVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, RightSectionSize will always be >0}
      RightSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if RightSectionSize=0 then exit;
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      {divide xlen by ylen}
      CurrRightX:=Poly^[vrtx1].x;
      RightStepX:=mFixedDiv(Poly^[vrtx2].x-CurrRightX,height);

--      DECLARE var prestep:fixed; begin
--         prestep:=mFixedRound(Poly^[vrtx1].y) - Poly^[vrtx1].y;
--         CurrRightX+:=mFixedMul(prestep,LeftStepX);
--      end;
      LoadColor(Poly^[vrtx1].color,RightColor);
      LoadColor(Poly^[vrtx2].color,Color2);
      RightColorStep.g:=mFixedDiv(color2.g-RightColor.g,height);
      if DACtype=BGRdac then begin
        RightColorStep.r:=mFixedDiv(color2.r-RightColor.r,height);
        RightColorStep.b:=mFixedDiv(color2.b-RightColor.b,height);
      end else begin
{exchange blue and red values in starting colors. Use height as temporary variable}
        RightColorStep.b:=mFixedDiv(color2.r-RightColor.r,height);
        RightColorStep.r:=mFixedDiv(color2.b-RightColor.b,height);
        height:=RightColor.r; RightColor.r:=RightColor.b; RightColor.b:=height;
      end;
--      LoadColor(Poly^[vrtx1].color+BaseColor,RightColor);
  end;

var hsize:longint;
    temp,x,width:fixed;
    steptable:array[1..3*2] of word;
    gstep,rstep:fixed;
    CurrColor:word;
    g_int_step,b_g_step:fixed;
    sign:byte;
Begin
   BaseColor:=color shl 16; -- translate base color into 16.16 fixed
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection  {search for first usable section}
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hsize>0 then begin
       width:=CurrRightX-CurrLeftX;
       ColorStep.r:=mFixedDiv(RightColor.r-LeftColor.r,width);
       ColorStep.g:=mFixedDiv(RightColor.g-LeftColor.g,width);
       ColorStep.b:=mFixedDiv(RightColor.b-LeftColor.b,width);

--       steptable[2]:=mTrunc(ColorStep.r) shl VesaModeInfo.RedFieldPosition;
--       steptable[1]:=steptable[2]+1 shl VesaModeInfo.RedFieldPosition;
--       steptable[4]:=mTrunc(ColorStep.g) shl VesaModeInfo.GreenFieldPosition;
--       steptable[3]:=steptable[4]+1 shl VesaModeInfo.GreenFieldPosition;
--       steptable[6]:=mTrunc(ColorStep.b);
--       steptable[5]:=steptable[6]+1;
--       CurrColor:=GetRGBColor(LeftColor.r shr 16,LeftColor.g shr 16,LeftColor.b shr 16);

       asm
         mov edi,dword ptr Where
         mov eax,offs
         add eax,x

         mov ecx,hsize

         lea edi,[edi+eax*2]

         lea edi,[edi+ecx*2]
         xor ecx,-1

         inc ecx


         mov edx,LeftColor.b   -- get fraction part in edx
         mov eax,LeftColor.r   -- pack it into word

         shl edx,16
         shr eax,5

         mov dx,ax

         mov esi,ColorStep.b
         mov eax,ColorStep.r  -- pack dword into word with sign
         shl esi,16

         shl eax,16-5
         shr eax,16
         mov si,ax

         mov eax,ColorStep.g
         shl eax,16
         mov ax,word ptr[ColorStep.b+2] -- get whole part of step
         mov b_g_step,eax

         mov eax,LeftColor.g
         shl eax,16
         mov ax,word ptr[LeftColor.b+2] -- get whole part of step


         mov ebx,ColorStep.g
         shr ebx,16-5
         --and ebx,$7E0 --11111100000b
         or  ebx,$1F  --11111b
         mov g_int_step,ebx

         mov ebx,LeftColor.g   -- get whole part of fixed
         shr ebx,16-5
         and ebx,$7E0 --11111100000b


---  This inner loop uses 16 Bit for fraction part of Blue&Green, and
---    only 11 bit for fraction part of Red
---
---   !=zero (0) Not modyfieble or can be changed!!
---   @=can be modyfied
---   b=Blue Frac ; B=blue int; a=blue frac step; A=blue int step
---   g=Green Frac ; G=green int; c=green frac step; C=green int step
---   r=red Frac ; R=red int; d=red frac step; D=red int step
---        eax=gggg gggg gggg gggg @@@@ @@@@ @@@@ BBBB
---   b_g_step=cccc cccc cccc cccc @@@@ @@@@ @@@@ AAAA
---        edx=bbbb bbbb bbbb bbbb RRRR Rrrr rrrr rrrr
---        esi=aaaa aaaa aaaa aaaa DDDD Dddd dddd dddd
---        ebx=@@@@ @@@@ @@@@ @@@@ !!!! !GGG GGG! !!!!
--- g_int_step=@@@@ @@@@ @@@@ @@@@ @@@@ @CCC CCC1 1111
---        ecx=counter
---        edi=dest ptr

      @@inner:
         add edx,esi                       -- bfrac+=bfracstep -- r+=rstep
         adc eax,b_g_step                  -- bwhole+=bwholestep+carry -- gfrac+=gfracstep
         adc bx,word ptr g_int_step        -- gwhole+=gwholestep+carry
         mov ah,dh                         -- move red value to dest
         and bx,$7E0   --0000011111100000b -- get clear green
         and ax,$0F81F --1111100000011111b -- get clear red&blue
         or  ax,bx
         mov [edi+ecx*2],ax
         inc ecx
         jnz @@inner

---  This new inner loop uses 16 Bit for fraction part of all components
---
---   !=zero (0) Not modyfieble or can be changed!!
---   @=can be modyfied
---   b=Blue Frac ; B=blue int; a=blue frac step; A=blue int step
---   g=Green Frac ; G=green int; c=green frac step; C=green int step
---   r=red Frac ; R=red int; d=red frac step; D=red int step
---               eax=gggg gggg gggg gggg RRRR R!!! !!!! BBBB
---          b_g_step=cccc cccc cccc cccc !!!! !@@@ @@@@ AAAA
---               edx=bbbb bbbb bbbb bbbb DDDD D111 @@@@ @@@@
---               esi=aaaa aaaa aaaa aaaa !!!! !!!! @@@@ @@@@
---               ebx=rrrr rrrr rrrr rrrr !!!! !GGG GGG! !!!!
--- r_frac_g_int_step=dddd dddd dddd dddd @@@@ @CCC CCC1 1111
---               ecx=counter
---               edi=dest ptr
-------------------------------------------------------------
{
         mov eax,ColorStep.g
         shl eax,16
         mov ax,word ptr [ColorStep.b+2]
         mov sign,0
         and ax,ax
         jns @@nosign
           mov sign,$0F0
           neg ax
      @@nosign:
         mov b_g_step,eax

         mov eax,LeftColor.g
         shl eax,16
         mov ax,word ptr [LeftColor.r+2]
         shl ax,4+3
         mov al,byte ptr [LeftColor.b+2]
---------------------------------------------------
         mov edx,LeftColor.b
         shl edx,16
         mov dx,word ptr [ColorStep.r+2]
         shl dx,4+3
         or  dx,$0700

         mov esi,ColorStep.b
         shl esi,16


         mov ebx,ColorStep.r
         shl ebx,16
         mov bx,word ptr [ColorStep.g+2]
         shl bx,5
         or bx,$1F  --00011111b
         mov g_int_step,ebx
         mov ebx,LeftColor.r
         shl ebx,16
         mov bx,word ptr [LeftColor.g+2]
         shl bx,5


@@inner:
         add edx,esi                       -- bfrac+=bfracstep
--         adc al,sign
         add eax,b_g_step                  -- bwhole+=bwholestep+carry -- gfrac+=gfracstep
         adc ebx,g_int_step         -- gwhole+=gwholestep+carry -- rfrac+=rfracstep
         adc ah,dh                         -- rwhole+=rwholestep
         and bx,$7E0   --0000011111100000b -- get clear green
         and ax,$0F81F --1111100000011111b -- get clear red&blue
         or  ax,bx
         mov [edi+ecx*2],ax
         inc ecx
         jnz @@inner

}
       end;
   end;
   offs+:=Where.SizeX;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else begin
      CurrLeftX+:=LeftStepX;
      LeftColor.r+:=LeftColorStep.r;
      LeftColor.g+:=LeftColorStep.g;
      LeftColor.b+:=LeftColorStep.b;
   end;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else begin
      CurrRightX+:=RightStepX;
      RightColor.r+:=RightColorStep.r;
      RightColor.g+:=RightColorStep.g;
      RightColor.b+:=RightColorStep.b;
   end;

until false;
end;
