{The texture inner loop looks like this:                                       }
{        ͻ                           }
{         UPPER 16BIT         LOWER 16BIT                 lea edi,[edi+ecx] }
{͹         neg ecx           }
{  REG     HI WORD      HI BYTE      LO BYTE      @@inner:                }
{͹         mov al,[ebx]      }
{  EAX   Curr-X frac      ---          ---              add edx,ebp       }
{͹         adc bh,dh         }
{  ECX       ---       Scan Line Width                   add eax,esi       }
{͹         adc bl,dl         }
{  EDX   Curr-Y frac  Y-int step    X-int step          mov [edi+ecx],al  }
{͹         inc ecx           }
{  EBP   Y-frac step      ---          ---              jnz @@inner       }
{͹                           }
{  EBX   Texture ptr   Curr-Y int   Curr-X int                            }
{͹                           }
{  ESI   X-frac step      ---          ---                                }
{͹                           }
{  EDI             Destination pointer                                      }
{ͼ                           }
{                                                                              }
{ Texture must be 256*256 bitmap aligned on 64K (low 16 bit's=zero)            }
{ Only pointer to texture in texture record is used                            }

Procedure RenderTexture16(poly:TPolygonPtr; txt:TTexture; Num:byte; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon=array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - filling color for flat polygons }
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;
    LeftTextStepX,RightTextStepX,LeftTextStepY,RightTextStepY,
    CurrLeftTextX,CurrLeftTextY,CurrRightTextX,CurrRightTextY,
    CurrTextX,CurrTextY,TextStepX,TextStepY:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

    prestep:fixed;
    TxtLine:array[1..1024] of byte;

{$I src\include\txtscan.pas}

var hsize:longint;
    width:fixed;
    temp:fixed;
    x:fixed;
Begin
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   {search for first usable left & right sections}
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hSize>0 then begin
      width:=CurrRightX-CurrLeftX;
      TextStepX:=mFixedDiv(CurrRightTextX-CurrLeftTextX,width);
      TextStepY:=mFixedDiv(CurrRightTextY-CurrLeftTextY,width);
      CurrTextX:=CurrLeftTextX;
      CurrTextY:=CurrLeftTextY;

--      Prestep:=mFixedRound(CurrLeftX)-CurrLeftX;
--      CurrTextX:=CurrLeftTextX+mFixedMul(Prestep,TextStepX);
--      CurrTextY:=CurrLeftTextY+mFixedMul(Prestep,TextStepY);

      asm
         mov ebx,dword ptr Txt  -- get texture pointer

         mov bl,byte ptr [CurrTextX+2]
         mov bh,byte ptr [CurrTextY+2]

         mov ecx,hsize

         mov edx, CurrTextY  -- mov dx,ylo
         shl edx,16

         mov dl,byte ptr [TextStepX+2]
         mov dh,byte ptr [TextStepY+2]


         mov esi,TextStepX      --   mov si,xloadd
         shl esi,16

         mov eax,CurrTextX      --   mov ax,xlo
         shl eax,16

         lea edi,TxtLine -- get destination segment

push ebp
         mov ebp,TextStepY      --   mov bp,yloadd
         shl ebp,16

         -- put first byte --

         shr ecx,1
         jnc @@skipOne

         mov al,[ebx]
         add edx,ebp
         adc bh,dh
         add eax,esi
         adc bl,dl
         mov [edi],al
         inc edi
         jcxz @@done   -- if no more pixels in this line then exit

    @@skipOne:
         lea edi,[edi+ecx*2]
         xor ecx,-1
         inc ecx
    @@inner:
         -- calc first pixel --
         mov al,[ebx]
         add edx,ebp
         adc bh,dh
         add eax,esi
         adc bl,dl

         -- calc second pixel --
         mov ah,[ebx]
         add edx,ebp
         adc bh,dh
         add eax,esi
         adc bl,dl

         -- put both pixels --
         mov [edi+ecx*2],ax
         inc ecx
         jnz @@inner
@@done:
pop ebp
         mov ecx,hsize
         lea esi,TxtLine
         mov edi,dword ptr Where
         mov ebx,offs
         add ebx,x
         lea edi,[edi+ebx*2]
         lea edi,[edi+ecx*2]
         xor ecx,-1
         inc ecx
         mov ebx,Txt.pal
         sub eax,eax
      @@ConvertHLine:
         lodsb
         mov dx,[ebx+eax*2]
         mov [edi+ecx*2],dx
         inc ecx
         jnz @@ConvertHLine

      end;

   end;

   offs+:=Where.SizeX;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else begin
      CurrLeftX+:=LeftStepX;
      CurrLeftTextX+:=LeftTextStepX;
      CurrLeftTextY+:=LeftTextStepY;
   end;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else begin
      CurrRightX+:=RightStepX;
      CurrRightTextX+:=RightTextStepX;
      CurrRightTextY+:=RightTextStepY;
   end;

until false;
end;

(**************************************************************************)
(**************************************************************************)
(**************************************************************************)
(**************************************************************************)
(**************************************************************************)

Procedure RenderLambertTexture16(poly:TPolygonPtr; txt:TTexture; Num:byte; color:word; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon=array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - Adding color for texture polygons. Color wrapping not supported,}
{          i.e. if after adding color to first pixel, and it will be overflow,}
{          then it will affect on second color }
{ !!NOTE!! Texture must be 256*256 bitmap aligned on 64K (low 16 bit's=zero)}
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;
    LeftTextStepX,RightTextStepX,LeftTextStepY,RightTextStepY,
    CurrLeftTextX,CurrLeftTextY,CurrRightTextX,CurrRightTextY,
    CurrTextX,CurrTextY,TextStepX,TextStepY:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

    prestep:fixed;

{$I src\include\txtscan.pas}

var hsize:longint;
    width:fixed;
    temp:fixed;
    x:fixed;
Begin
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   {search for first usable left & right sections}
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
   asm
     mov al,byte ptr color
     mov byte ptr [color+1],al
   end;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hSize>0 then begin
      width:=CurrRightX-CurrLeftX;
      TextStepX:=mFixedDiv(CurrRightTextX-CurrLeftTextX,width);
      TextStepY:=mFixedDiv(CurrRightTextY-CurrLeftTextY,width);

--      Prestep:=mFixedRound(CurrLeftX)-CurrLeftX;
--      CurrTextX:=CurrLeftTextX+mFixedMul(Prestep,TextStepX);
--      CurrTextY:=CurrLeftTextY+mFixedMul(Prestep,TextStepY);

      CurrTextX:=CurrLeftTextX;
      CurrTextY:=CurrLeftTextY;

      asm
         mov ebx,dword ptr Txt  -- get texture pointer

         mov bl,byte ptr [CurrTextX+2]
         mov bh,byte ptr [CurrTextY+2]

         mov ecx,hsize

         mov edx, CurrTextY  -- mov dx,ylo
         shl edx,16

         mov dl,byte ptr [TextStepX+2]
         mov dh,byte ptr [TextStepY+2]


         mov esi,TextStepX      --   mov si,xloadd
         shl esi,16

         mov eax,CurrTextX      --   mov ax,xlo
         shl eax,16

         mov edi,dword ptr Where  -- get destination segment
         add edi,offs
         add edi,x

mov temp,esp       -- save esp register in temporary variable
         mov esp,TextStepY      --  change ebp register to esp
         shl esp,16

         -- put first byte --

         shr ecx,1
         jnc @@skipOne

         mov al,[ebx]
         add edx,esp
         adc bh,dh
         add eax,esi
         adc bl,dl
         add al,byte ptr color
         mov [edi],al
         inc edi
         jcxz @@done   -- if no more pixels in this line then exit

    @@skipOne:
         lea edi,[edi+ecx*2]
         xor ecx,-1
         inc ecx
    @@inner:
         -- calc first pixel --
         mov al,[ebx]
         add edx,esp
         adc bh,dh
         add eax,esi
         adc bl,dl

         -- calc second pixel --
         mov ah,[ebx]
         add edx,esp
         adc bh,dh
         add eax,esi
         adc bl,dl

         -- put both pixels --
         add ax,color
         mov [edi+ecx*2],ax
         inc ecx
         jnz @@inner
@@done:
--pop ebp
mov esp,temp
      end;

   end;

   offs+:=Where.SizeX;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else begin
      CurrLeftX+:=LeftStepX;
      CurrLeftTextX+:=LeftTextStepX;
      CurrLeftTextY+:=LeftTextStepY;
   end;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else begin
      CurrRightX+:=RightStepX;
      CurrRightTextX+:=RightTextStepX;
      CurrRightTextY+:=RightTextStepY;
   end;

until false;
end;

{ Goraud inner loop is modified and looks like this:                        }
{         lea edi,[edi+ecx]                                                 }
{         xor ecx,-1                                                        }
{         inc ecx                                                           }
{    @@inner:                                                               }
{         mov al,[ebx]                                                      }
{         add edx,esp                         -- yfrac+:=yfrac_step         }
{         adc bh,dh                           -- yint+:=yint_step           }
{         add eax,XFracStep                   -- xfrac+:=xfrac_step         }
{         adc bl,dl                           -- xint+:=xint_step           }
{         add esi,ColorStepInv                -- colorfrac+:=colorfrac_step }
{         adc ah,byte ptr ColorStepInv        -- colorint+:=colorint_step   }
{         add al,ah                           -- TextColor+:=ColoInt        }
{         mov [edi+ecx],al                                                  }
{         inc ecx                                                           }
{         jnz @@inner                                                       }

Procedure RenderGoraudTexture16(poly:TPolygonPtr; txt:TTexture; Num:byte; color:word; Where:TPageType);
{ poly - pointer to polygon structure }
{ Polygon structure must have format polygon=array[1..n] of TVertex3dFix }
{ Num  - number of vertexes in poly}
{ Color - Adding color for texture polygons. Color wrapping not supported,}
{          i.e. if after adding color to first pixel, and it will be overflow,}
{          then it will affect on second color }
{ !!NOTE!! Texture must be 256*256 bitmap aligned on 64K (low 16 bit's=zero)}
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;
    LeftTextStepX,RightTextStepX,LeftTextStepY,RightTextStepY,
    CurrLeftTextX,CurrLeftTextY,CurrRightTextX,CurrRightTextY,
    CurrTextX,CurrTextY,TextStepX,TextStepY:fixed;
    ColorStep,LeftColor,RightColor,LeftColorStep,RightColorStep:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;

    prestep:fixed;
    BaseColor:fixed;

Procedure LeftSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      LeftVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      LeftVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, LeftSectionSize will always be >0}
      LeftSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if LeftSectionSize=0 then exit;
      {divide xlen by ylen}
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      CurrLeftX:=Poly^[vrtx1].x;
      LeftStepX:=mFixedDiv(Poly^[vrtx2].x-CurrLeftX,height);

--      prestep:=mFixedRound(Poly^[vrtx1].y)-Poly^[vrtx1].y;
--      CurrLeftX:=Poly^[vrtx1].x+mFixedMul(prestep,LeftStepX);

      CurrLeftTextX:=Poly^[vrtx1].u;
      CurrLeftTextY:=Poly^[vrtx1].v;
      LeftTextStepX:=mFixedDiv(Poly^[vrtx2].u-CurrLeftTextX,height);
      LeftTextStepY:=mFixedDiv(Poly^[vrtx2].v-CurrLeftTextY,height);

      LeftColor:=Poly^[vrtx1].color;
      LeftColorStep:=mFixedDiv(Poly^[vrtx2].color-LeftColor,height);
      LeftColor+:=BaseColor;
  end;

Procedure RightSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 4 then NewVertex=vertex number 1}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      RightVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      RightVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, RightSectionSize will always be >0}
      RightSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if RightSectionSize=0 then exit;
      {divide xlen by ylen}

      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      CurrRightX:=Poly^[vrtx1].x;
      RightStepX:=mFixedDiv(Poly^[vrtx2].x-CurrRightX,height);

--      prestep:=mFixedRound(Poly^[vrtx1].y)-Poly^[vrtx1].y;
--      CurrRightX:=Poly^[vrtx1].x+mFixedMul(prestep,RightStepX);

      CurrRightTextX:=Poly^[vrtx1].u;
      CurrRightTextY:=Poly^[vrtx1].v;
      RightTextStepX:=mFixedDiv(Poly^[vrtx2].u-CurrRightTextX,height);
      RightTextStepY:=mFixedDiv(Poly^[vrtx2].v-CurrRightTextY,height);

      RightColor:=Poly^[vrtx1].color;
      RightColorStep:=mFixedDiv(Poly^[vrtx2].color-RightColor,height);
      RightColor+:=BaseColor;
  end;

var hsize:longint;
    width:fixed;
    temp:fixed;
    x:fixed;
    XFracStep,ColorStepInv:fixed;
Begin
   BaseColor:=color*65536; -- translate base color into 16.16 fixed
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   {search for first usable left & right sections}
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
   asm
     mov al,byte ptr color
     mov byte ptr [color+1],al
   end;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hSize>0 then begin
      width:=CurrRightX-CurrLeftX;
      TextStepX:=mFixedDiv(CurrRightTextX-CurrLeftTextX,width);
      TextStepY:=mFixedDiv(CurrRightTextY-CurrLeftTextY,width);
      ColorStep:=mFixedDiv(RightColor-LeftColor,width);

--      Prestep:=mFixedRound(CurrLeftX)-CurrLeftX;
--      CurrTextX:=CurrLeftTextX+mFixedMul(Prestep,TextStepX);
--      CurrTextY:=CurrLeftTextY+mFixedMul(Prestep,TextStepY);

      CurrTextX:=CurrLeftTextX;
      CurrTextY:=CurrLeftTextY;

      asm
         mov ebx,dword ptr Txt  -- get texture pointer

         mov bl,byte ptr [CurrTextX+2]
         mov bh,byte ptr [CurrTextY+2]

         mov ecx,hsize

         mov edx,CurrTextY  -- mov dx,ylo
         shl edx,16

         mov dl,byte ptr [TextStepX+2]
         mov dh,byte ptr [TextStepY+2]


         mov eax,TextStepX      --   mov si,xloadd
         shl eax,16
         mov XFracStep,eax

         mov eax,ColorStep
         ror eax,16
         mov ColorStepInv,eax
         mov eax,LeftColor
         ror eax,16
         mov esi,eax

         mov eax,CurrTextX
         shl eax,16
         mov ah,byte ptr [LeftColor+2]

         mov edi,dword ptr Where  -- get destination segment
         add edi,offs
         add edi,x

mov temp,esp       -- save esp register in temporary variable
         mov esp,TextStepY      --  change ebp register to esp
         shl esp,16

         lea edi,[edi+ecx]
         xor ecx,-1
         inc ecx
    @@inner:
         mov al,[ebx]
         add edx,esp                         -- yfrac+:=yfrac_step
         adc bh,dh                           -- yint+:=yint_step
         add eax,XFracStep                   -- xfrac+:=xfrac_step
         adc bl,dl                           -- xint+:=xint_step
         add esi,ColorStepInv                -- colorfrac+:=colorfrac_step
         adc ah,byte ptr ColorStepInv        -- colorint+:=colorint_step
         add al,ah                           -- TextColor+:=ColoInt
         mov [edi+ecx],al
         inc ecx
         jnz @@inner
mov esp,temp
      end;

   end;

   offs+:=Where.SizeX;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else begin
      CurrLeftX+:=LeftStepX;
      CurrLeftTextX+:=LeftTextStepX;
      CurrLeftTextY+:=LeftTextStepY;
      LeftColor+:=LeftColorStep;
   end;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else begin
      CurrRightX+:=RightStepX;
      CurrRightTextX+:=RightTextStepX;
      CurrRightTextY+:=RightTextStepY;
      RightColor+:=RightColorStep;
   end;

until false;
end;
